package com.sztzjy.forex.trading_trading.common.mql5API;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.sztzjy.forex.trading_trading.entity.mql5Entity.CurrencyEntity;
import com.sztzjy.forex.trading_trading.entity.mql5Entity.ExchangeFrateEntity;
import com.sztzjy.forex.trading_trading.entity.mql5Entity.ForexData;
import com.sztzjy.forex.trading_trading.entity.mql5Entity.RmbquotEntity;
import com.sztzjy.forex.trading_trading.util.HttpUtils;
import org.apache.commons.lang3.StringUtils;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class Mql5API {

    //货币代码APPKEY
    private String CurrencyCode = "35510fd564e5b1a3455fe53e96cdce2e";
    //汇率APPKEY
    private String ExchangeRate = "41a4467c339f65ca86978cf5feb5f683";
    //查询货币代码地址
    private String CurrencyAddr = "http://op.juhe.cn/onebox/exchange/list?key=35510fd564e5b1a3455fe53e96cdce2e";
    //查询人民币牌价地址
    private String RmbquotAddr = "http://web.juhe.cn/finance/exchange/rmbquot?key=41a4467c339f65ca86978cf5feb5f683";
    //查询外汇汇率地址
    private String ExchangeFrateAddr = "http://web.juhe.cn/finance/exchange/frate?key=41a4467c339f65ca86978cf5feb5f683";


    //查询常见货币代码
    public CurrencyEntity getCurrencyList() {
        try {
            String returnStr = HttpUtils.sendGet(CurrencyAddr);
            ObjectMapper objectMapper = new ObjectMapper();
            CurrencyEntity currency = objectMapper.readValue(returnStr, CurrencyEntity.class);
            return currency;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    //查询人民币牌价
    public RmbquotEntity getRmbquot() {
        try {
            String returnStr = HttpUtils.sendGet(RmbquotAddr);
            ObjectMapper objectMapper = new ObjectMapper();
            RmbquotEntity rmbquot = objectMapper.readValue(returnStr, RmbquotEntity.class);
            return rmbquot;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    //查询外汇汇率
    public ExchangeFrateEntity getExchangeFrate() {
        try {
            String returnStr = HttpUtils.sendGet(ExchangeFrateAddr);
            ObjectMapper objectMapper = new ObjectMapper();
            ExchangeFrateEntity exchangeFrate = objectMapper.readValue(returnStr, ExchangeFrateEntity.class);
            return exchangeFrate;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    //查询外汇汇率 返回ForexData对象
    public List<ForexData> getMarketQuotation() {
        try {
            String returnStr = HttpUtils.sendGet(ExchangeFrateAddr);
            JSONObject jsonObject = JSONObject.parseObject(returnStr);
            JSONArray jsonArray = (JSONArray) jsonObject.get("result");
            JSONObject dataObject = jsonArray.getJSONObject(0);
            ObjectMapper objectMapper = new ObjectMapper();
            List<ForexData> forexDataList = new ArrayList<>();
            for (String key : dataObject.keySet()) {
                String value = dataObject.getString(key);
                ForexData forexData = objectMapper.readValue(value, ForexData.class);
                forexDataList.add(forexData);
            }
            return forexDataList;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    //根据code查询外汇汇率
    public ForexData getMarketQuotationByCode(String code) {
        try {
            String returnStr = HttpUtils.sendGet(ExchangeFrateAddr);
            JSONObject jsonObject = JSONObject.parseObject(returnStr);
            JSONArray jsonArray = (JSONArray) jsonObject.get("result");
            JSONObject dataObject = jsonArray.getJSONObject(0);
            ObjectMapper objectMapper = new ObjectMapper();
            for (String key : dataObject.keySet()) {
                String value = dataObject.getString(key);
                ForexData forexData = objectMapper.readValue(value, ForexData.class);
                if(forexData.getCode().equals(code)){
                    return forexData;
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

}
