package com.sztzjy.forex.trading_trading.controller;


import com.sztzjy.forex.trading_trading.annotation.Permission;
import com.sztzjy.forex.trading_trading.annotation.aspect.PermissionType;
import com.sztzjy.forex.trading_trading.config.security.JwtUser;
import com.sztzjy.forex.trading_trading.config.security.TokenProvider;
import com.sztzjy.forex.trading_trading.mappers.MemberMapper;
import com.sztzjy.forex.trading_trading.service.MemberService;
import com.sztzjy.forex.trading_trading.util.ResultEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@Api(tags = "统计管理")
@RestController
@RequiredArgsConstructor
@RequestMapping("api/statistical")
public class StatisticalController {


    private final HttpServletRequest request;

    private final MemberService memberService;

    @Permission(codes = PermissionType.DATA_STATISTICS)
    @ApiOperation("教师端----班级成绩走势统计")
    @GetMapping("classScoreTrend")
    public ResultEntity<List<Map<String,Object>>> classScoreTrend() {
        JwtUser currentUser = TokenProvider.getJWTUser(request);
        return new ResultEntity(HttpStatus.OK,memberService.classScoreTrend(currentUser.getSchoolId()));
    }


}
