package com.sztzjy.forex.trading_trading.dto;


import com.sztzjy.forex.trading_trading.entity.GradeWeight;
import com.sztzjy.forex.trading_trading.entity.Member;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

@ApiModel("教师端用户操作数据出参")
@Getter
@Setter
@Data
public class MemberVO {

    @ApiModelProperty("实训名称")
    public String trainingName;
    @ApiModelProperty("班级名称")
    public String classGrade;
    @ApiModelProperty("学生姓名")
    public String name;
    @ApiModelProperty("学生学号")
    public String studentNumber;
    @ApiModelProperty("累计收益")
    public Double cumulativeProfitLoss;
    @ApiModelProperty("收益率")
    public Double yield;
    @ApiModelProperty("交易实训成绩")
    public Double tradeTrainingScore;
    @ApiModelProperty("实训报告成绩")
    public Double trainingReportScore;
    @ApiModelProperty("总成绩")
    public Double totalScore;
    @ApiModelProperty("排名")
    public Integer stuRank;
    @ApiModelProperty("memberId")
    public String memberId;
    @ApiModelProperty("实训id")
    public String trainingId;


    public static MemberVO create(MemberVO vo, List<GradeWeight> gradeWeights) {
        for (GradeWeight weight : gradeWeights) {
            if (vo.getYield() > weight.getMinProfit() && vo.getYield() <= weight.getMaxProfit()) {
                vo.setTradeTrainingScore(weight.getActualScore());
                break;
            }
        }
        return vo;
    }

    public static List<MemberVO> create(List<MemberVO> vos, List<GradeWeight> gradeWeights) {
        List<MemberVO> result = new ArrayList<>();
        vos.forEach(vo -> {
            result.add(create(vo, gradeWeights));
        });
        return result;
    }
}
