package com.sztzjy.forex.trading_trading.service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sztzjy.forex.trading_trading.entity.Member;
import com.sztzjy.forex.trading_trading.entity.MemberExample;
import com.sztzjy.forex.trading_trading.entity.Training;
import com.sztzjy.forex.trading_trading.entity.TrainingExample;
import com.sztzjy.forex.trading_trading.mappers.MemberMapper;
import com.sztzjy.forex.trading_trading.mappers.TrainingMapper;
import lombok.RequiredArgsConstructor;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
@RequiredArgsConstructor
public class IndexService {
    private final MemberMapper memberMapper;
    private final TrainingMapper trainingMapper;

    //TODO 实训任务结束后系统自动显示模拟交易实训成绩，教师评分之后显示实验报告成绩。

    //  首页分页 排序 模糊查询
    public PageInfo<Member> findByConditions(Integer index, Integer size, String classGrade, String studentNumber, String name, Date startTime, String trainingName, Integer schoolId) {
        TrainingExample trainingExample = new TrainingExample();
        PageHelper.startPage(index, size);
//        跳转到首页 没有参数 显示所有
        if (classGrade == null && studentNumber == null && name == null && startTime == null && trainingName == null) {
            MemberExample memberExample = new MemberExample();
            MemberExample.Criteria criteria = memberExample.createCriteria();
            if (schoolId != null) {
                criteria.andSchoolIdEqualTo(schoolId);
            }
            memberExample.setOrderByClause("yield DESC");
            List<Member> members1 = memberMapper.selectByExample(memberExample);
            for (int i = 1; i <= members1.size(); i++) {
                for (Member member : members1) {
                    member.setStuRank(i);
                    i++;
                }
            }
            return new PageInfo<>(members1);
        }
        TrainingExample.Criteria criteria = trainingExample.createCriteria();
        if (schoolId != null) {
            criteria.andSchoolIdEqualTo(schoolId);
        }
        if (StringUtils.isNotEmpty(trainingName)) {
            criteria.andTrainingNameEqualTo(trainingName);
        }
        if (startTime!=null) {
            criteria.andStartTimeEqualTo(startTime);
        }

        List<Training> trainings = null;
        if (StringUtils.isNotEmpty(trainingName) || startTime!=null) {
            trainings = trainingMapper.selectByExample(trainingExample);
        }
        List<Member> members = new ArrayList<>();
        if (trainings != null && !trainings.isEmpty()) {
            //根据trainingName查到了对象
            for (Training training : trainings) {
                MemberExample memberExample = new MemberExample();
                MemberExample.Criteria criteria1 = memberExample.createCriteria();
                String trainingId = training.getTrainingId();
                if (trainingId != null) {
                    criteria1.andTrainingIdEqualTo(trainingId);
                }
                if (StringUtils.isNotEmpty(classGrade)) {
                    criteria1.andClassGradeLike("%" + classGrade + "%");
                }
                if (StringUtils.isNotEmpty(studentNumber)) {
                    criteria1.andStudentNumberLike("%" + studentNumber + "%");
                }
                if (StringUtils.isNotEmpty(name)) {
                    criteria1.andNameLike("%" + name + "%");
                }
                memberExample.setOrderByClause("yield DESC");
                List<Member> membersForTraining = memberMapper.selectByExample(memberExample);
                for (int i = 1; i <= membersForTraining.size(); i++) {
                    for (Member member : membersForTraining) {
                        member.setStuRank(i);
                        i++;
                    }
                }
                members.addAll(membersForTraining);
            }
            return new PageInfo<>(members);
        }
        //没有传training表中两个参数时，直接查member表
        MemberExample memberExample = new MemberExample();
        MemberExample.Criteria criteria1 = memberExample.createCriteria();
        if (schoolId != null) {
            criteria1.andSchoolIdEqualTo(schoolId);
        }
        if (StringUtils.isNotEmpty(classGrade)) {
            criteria1.andClassGradeLike("%" + classGrade + "%");
        }
        if (StringUtils.isNotEmpty(studentNumber)) {
            criteria1.andStudentNumberLike("%" + studentNumber + "%");
        }
        if (StringUtils.isNotEmpty(name)) {
            criteria1.andNameLike("%" + name + "%");
        }
        memberExample.setOrderByClause("yield DESC");
        PageHelper.startPage(index, size);
        List<Member> membersForTraining = memberMapper.selectByExample(memberExample);
        for (int i = 1; i <= membersForTraining.size(); i++) {
            for (Member member : membersForTraining) {
                member.setStuRank(i);
                i++;
            }
        }
        return new PageInfo<>(membersForTraining);
    }
}
