package com.sztzjy.forex.trading_trading.service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sztzjy.forex.trading_trading.entity.PendingOrder;
import com.sztzjy.forex.trading_trading.entity.PendingOrderExample;
import com.sztzjy.forex.trading_trading.entity.TakeStash;
import com.sztzjy.forex.trading_trading.mappers.PendingOrderMapper;
import io.swagger.models.auth.In;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class PendingOrderService {
    @Autowired
    PendingOrderMapper pendingOrderMapper;

    public void insert(PendingOrder pendingOrder){
        pendingOrderMapper.insert(pendingOrder);
    }

    public PageInfo<PendingOrder> selectByTrainingIdAndStatusAndMemberId(PendingOrder pendingOrder, Integer pageNum,Integer pageSize){
        PageHelper.startPage(pageNum, pageSize);
        PendingOrderExample pendingOrderExample = new PendingOrderExample();
        PendingOrderExample.Criteria criteria = pendingOrderExample.createCriteria();
        criteria.andMemberIdEqualTo(pendingOrder.getMemberId()).andTrainingIdEqualTo(pendingOrder.getTrainingId()).andStatusEqualTo(pendingOrder.getStatus());
        List<PendingOrder> pendingOrders = pendingOrderMapper.selectByExample(pendingOrderExample);
        PageInfo<PendingOrder> pageInfo = new PageInfo<>(pendingOrders);
        return pageInfo;
    }

    public void cancelOrder(String pendingOrderId){
        pendingOrderMapper.deleteByPrimaryKey(pendingOrderId);
    }

}
