package com.sztzjy.forex.trading_trading.service;

import cn.hutool.core.util.IdUtil;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sztzjy.forex.trading_trading.entity.TakeStash;
import com.sztzjy.forex.trading_trading.entity.TakeStashExample;
import com.sztzjy.forex.trading_trading.mappers.TakeStashMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class TakeStashService {
    @Autowired
    TakeStashMapper takeStashMapper;

    public void insertTakeStash(TakeStash takeStash){
        takeStash.setStashId(IdUtil.simpleUUID());
        takeStashMapper.insert(takeStash);
    }

    public PageInfo<TakeStash> findTakeStashByTrainingIdAndMemberIdAndStatus(String trainingId, String memberId, Integer status,Integer pageNum,Integer pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        TakeStashExample example=new TakeStashExample();
        TakeStashExample.Criteria criteria = example.createCriteria();
        criteria.andMemberIdEqualTo(memberId).andTrainingIdEqualTo(trainingId).andStatusEqualTo(status);
        List<TakeStash> takeStashes = takeStashMapper.selectByExample(example);
        PageInfo<TakeStash> pageInfo = new PageInfo<>(takeStashes);
        return pageInfo;
    }

    public List<TakeStash> selectAllByMemberIdAndStatus(String memberId, Integer status) {
        TakeStashExample example=new TakeStashExample();
        TakeStashExample.Criteria criteria = example.createCriteria();
        criteria.andMemberIdEqualTo(memberId).andStatusEqualTo(status);
        List<TakeStash> takeStashes = takeStashMapper.selectByExample(example);
        return takeStashes;
    }

    public TakeStash selectByPrimaryKey(String stashId){
        TakeStash takeStash = takeStashMapper.selectByPrimaryKey(stashId);
        return takeStash;
    }

    public void updateByPrimaryKeySelective(TakeStash takeStash){
        takeStashMapper.updateByPrimaryKeySelective(takeStash);
    }

    public void updateWinLossByPrimaryKey(TakeStash takeStash){
        takeStashMapper.updateWinLossByPrimaryKey(takeStash);
    }

    public List<TakeStash> findTakeStashByTrainingIdAndMemberIdAndStatusAndTradingCode(String trainingId, String memberId, int status, String tradingCode) {
        TakeStashExample example=new TakeStashExample();
        TakeStashExample.Criteria criteria = example.createCriteria();
        criteria.andMemberIdEqualTo(memberId).andTrainingIdEqualTo(trainingId).andStatusEqualTo(status).andTradingCodeEqualTo(tradingCode);
        List<TakeStash> takeStashes = takeStashMapper.selectByExample(example);
        return takeStashes;
    }
}
